/* gca-diagnostic-colors.c generated by valac 0.20.1, the Vala compiler
 * generated from gca-diagnostic-colors.vala, do not modify */

/*
 * This file is part of gedit-code-assistant.
 *
 * Copyright (C) 2011 - Jesse van den Kieboom
 *
 * gedit-code-assistant is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gedit-code-assistant is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gedit-code-assistant.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define GCA_TYPE_DIAGNOSTIC_COLORS (gca_diagnostic_colors_get_type ())
#define GCA_DIAGNOSTIC_COLORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GCA_TYPE_DIAGNOSTIC_COLORS, GcaDiagnosticColors))
#define GCA_DIAGNOSTIC_COLORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GCA_TYPE_DIAGNOSTIC_COLORS, GcaDiagnosticColorsClass))
#define GCA_IS_DIAGNOSTIC_COLORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GCA_TYPE_DIAGNOSTIC_COLORS))
#define GCA_IS_DIAGNOSTIC_COLORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GCA_TYPE_DIAGNOSTIC_COLORS))
#define GCA_DIAGNOSTIC_COLORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GCA_TYPE_DIAGNOSTIC_COLORS, GcaDiagnosticColorsClass))

typedef struct _GcaDiagnosticColors GcaDiagnosticColors;
typedef struct _GcaDiagnosticColorsClass GcaDiagnosticColorsClass;
typedef struct _GcaDiagnosticColorsPrivate GcaDiagnosticColorsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GCA_DIAGNOSTIC_TYPE_SEVERITY (gca_diagnostic_severity_get_type ())
typedef struct _GcaParamSpecDiagnosticColors GcaParamSpecDiagnosticColors;

struct _GcaDiagnosticColors {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GcaDiagnosticColorsPrivate * priv;
};

struct _GcaDiagnosticColorsClass {
	GTypeClass parent_class;
	void (*finalize) (GcaDiagnosticColors *self);
};

struct _GcaDiagnosticColorsPrivate {
	GdkRGBA d_errorColor;
	GdkRGBA d_warningColor;
	GdkRGBA d_infoColor;
};

typedef enum  {
	GCA_DIAGNOSTIC_SEVERITY_NONE,
	GCA_DIAGNOSTIC_SEVERITY_INFO,
	GCA_DIAGNOSTIC_SEVERITY_WARNING,
	GCA_DIAGNOSTIC_SEVERITY_DEPRECATED,
	GCA_DIAGNOSTIC_SEVERITY_ERROR,
	GCA_DIAGNOSTIC_SEVERITY_FATAL
} GcaDiagnosticSeverity;

struct _GcaParamSpecDiagnosticColors {
	GParamSpec parent_instance;
};


static gpointer gca_diagnostic_colors_parent_class = NULL;

gpointer gca_diagnostic_colors_ref (gpointer instance);
void gca_diagnostic_colors_unref (gpointer instance);
GParamSpec* gca_param_spec_diagnostic_colors (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gca_value_set_diagnostic_colors (GValue* value, gpointer v_object);
void gca_value_take_diagnostic_colors (GValue* value, gpointer v_object);
gpointer gca_value_get_diagnostic_colors (const GValue* value);
GType gca_diagnostic_colors_get_type (void) G_GNUC_CONST;
#define GCA_DIAGNOSTIC_COLORS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GCA_TYPE_DIAGNOSTIC_COLORS, GcaDiagnosticColorsPrivate))
enum  {
	GCA_DIAGNOSTIC_COLORS_DUMMY_PROPERTY
};
GcaDiagnosticColors* gca_diagnostic_colors_new (GtkStyleContext* context);
GcaDiagnosticColors* gca_diagnostic_colors_construct (GType object_type, GtkStyleContext* context);
static void gca_diagnostic_colors_update_color (GcaDiagnosticColors* self, GtkStyleContext* context, const gchar* color_name, GdkRGBA* defcol, gdouble alpha, GdkRGBA* result);
static void gca_diagnostic_colors_mix_colors (GcaDiagnosticColors* self, GdkRGBA* source, GdkRGBA* dest, GdkRGBA* result);
void gca_diagnostic_colors_mix_in_widget (GcaDiagnosticColors* self, GtkWidget* widget);
void gca_diagnostic_colors_mix_in_color (GcaDiagnosticColors* self, GtkWidget* widget, GdkRGBA* dest);
GType gca_diagnostic_severity_get_type (void) G_GNUC_CONST;
GdkRGBA* gca_diagnostic_colors_get (GcaDiagnosticColors* self, GcaDiagnosticSeverity severity);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
void gca_diagnostic_colors_get_error_color (GcaDiagnosticColors* self, GdkRGBA* result);
void gca_diagnostic_colors_get_warning_color (GcaDiagnosticColors* self, GdkRGBA* result);
void gca_diagnostic_colors_get_info_color (GcaDiagnosticColors* self, GdkRGBA* result);
static void gca_diagnostic_colors_finalize (GcaDiagnosticColors* obj);


GcaDiagnosticColors* gca_diagnostic_colors_construct (GType object_type, GtkStyleContext* context) {
	GcaDiagnosticColors* self = NULL;
	GtkStyleContext* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA _tmp2_ = {0};
	GtkStyleContext* _tmp3_;
	GdkRGBA _tmp4_ = {0};
	GdkRGBA _tmp5_ = {0};
	GtkStyleContext* _tmp6_;
	GdkRGBA _tmp7_ = {0};
	GdkRGBA _tmp8_ = {0};
#line 31 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 31 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self = (GcaDiagnosticColors*) g_type_create_instance (object_type);
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = context;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_.red = (gdouble) 1;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_.green = (gdouble) 0;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_.blue = (gdouble) 0;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_.alpha = (gdouble) 1;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, _tmp0_, "error_bg_color", &_tmp1_, 0.5, &_tmp2_);
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_errorColor = _tmp2_;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_ = context;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_.red = (gdouble) 1;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_.green = 0.5;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_.blue = (gdouble) 0;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_.alpha = (gdouble) 1;
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, _tmp3_, "warning_bg_color", &_tmp4_, 0.5, &_tmp5_);
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_warningColor = _tmp5_;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp6_ = context;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.red = (gdouble) 0;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.green = (gdouble) 0;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.blue = (gdouble) 1;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.alpha = (gdouble) 1;
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, _tmp6_, "info_bg_color", &_tmp7_, 0.5, &_tmp8_);
#line 43 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_infoColor = _tmp8_;
#line 31 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return self;
#line 168 "gca-diagnostic-colors.c"
}


GcaDiagnosticColors* gca_diagnostic_colors_new (GtkStyleContext* context) {
#line 31 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return gca_diagnostic_colors_construct (GCA_TYPE_DIAGNOSTIC_COLORS, context);
#line 175 "gca-diagnostic-colors.c"
}


static void gca_diagnostic_colors_mix_colors (GcaDiagnosticColors* self, GdkRGBA* source, GdkRGBA* dest, GdkRGBA* result) {
	GdkRGBA _tmp0_ = {0};
	GdkRGBA mixed;
	GdkRGBA _tmp1_;
	gdouble _tmp2_;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
	GdkRGBA _tmp9_;
	gdouble _tmp10_;
	GdkRGBA _tmp11_;
	gdouble _tmp12_;
	GdkRGBA _tmp13_;
	gdouble _tmp14_;
	GdkRGBA _tmp15_;
	gdouble _tmp16_;
	GdkRGBA _tmp17_;
	gdouble _tmp18_;
	GdkRGBA _tmp19_;
	gdouble _tmp20_;
	GdkRGBA _tmp21_;
	gdouble _tmp22_;
	GdkRGBA _tmp23_;
	gdouble _tmp24_;
	GdkRGBA _tmp25_;
	gdouble _tmp26_;
	GdkRGBA _tmp27_;
	gdouble _tmp28_;
	GdkRGBA _tmp29_;
	gdouble _tmp30_;
	GdkRGBA _tmp31_;
	gdouble _tmp32_;
	GdkRGBA _tmp33_;
	gdouble _tmp34_;
	GdkRGBA _tmp35_;
	gdouble _tmp36_;
	GdkRGBA _tmp37_;
	gdouble _tmp38_;
	GdkRGBA _tmp39_;
	gdouble _tmp40_;
	GdkRGBA _tmp41_;
	gdouble _tmp42_;
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (source != NULL);
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (dest != NULL);
#line 51 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_.red = (gdouble) 0;
#line 51 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_.green = (gdouble) 0;
#line 51 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_.blue = (gdouble) 0;
#line 51 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_.alpha = (gdouble) 0;
#line 51 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	mixed = _tmp0_;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_ = *source;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp2_ = _tmp1_.alpha;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_ = *dest;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_ = _tmp3_.alpha;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp5_ = *source;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp6_ = _tmp5_.alpha;
#line 53 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	mixed.alpha = _tmp2_ + (_tmp4_ * (1 - _tmp6_));
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_ = *source;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp8_ = _tmp7_.red;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp9_ = *source;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp10_ = _tmp9_.alpha;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_ = *dest;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp12_ = _tmp11_.red;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp13_ = *dest;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp14_ = _tmp13_.alpha;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp15_ = *source;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp16_ = _tmp15_.alpha;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp17_ = mixed;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp18_ = _tmp17_.alpha;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	mixed.red = ((_tmp8_ * _tmp10_) + ((_tmp12_ * _tmp14_) * (1 - _tmp16_))) / _tmp18_;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp19_ = *source;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp20_ = _tmp19_.green;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp21_ = *source;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp22_ = _tmp21_.alpha;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp23_ = *dest;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp24_ = _tmp23_.green;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp25_ = *dest;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp26_ = _tmp25_.alpha;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp27_ = *source;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp28_ = _tmp27_.alpha;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp29_ = mixed;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp30_ = _tmp29_.alpha;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	mixed.green = ((_tmp20_ * _tmp22_) + ((_tmp24_ * _tmp26_) * (1 - _tmp28_))) / _tmp30_;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp31_ = *source;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp32_ = _tmp31_.blue;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp33_ = *source;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp34_ = _tmp33_.alpha;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp35_ = *dest;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp36_ = _tmp35_.blue;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp37_ = *dest;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp38_ = _tmp37_.alpha;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp39_ = *source;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp40_ = _tmp39_.alpha;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp41_ = mixed;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp42_ = _tmp41_.alpha;
#line 61 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	mixed.blue = ((_tmp32_ * _tmp34_) + ((_tmp36_ * _tmp38_) * (1 - _tmp40_))) / _tmp42_;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	*result = mixed;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return;
#line 336 "gca-diagnostic-colors.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 69 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return self ? g_object_ref (self) : NULL;
#line 343 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_mix_in_widget (GcaDiagnosticColors* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
	GtkStyleContext* _tmp1_ = NULL;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* ctx;
	GtkWidget* _tmp3_;
	GtkStateFlags _tmp4_ = 0;
	GdkRGBA _tmp5_ = {0};
	GdkRGBA dest;
	GtkWidget* _tmp6_;
	GdkRGBA _tmp7_;
#line 67 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 67 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (widget != NULL);
#line 69 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = widget;
#line 69 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_ = gtk_widget_get_style_context (_tmp0_);
#line 69 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 69 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	ctx = _tmp2_;
#line 71 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_save (ctx);
#line 72 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_add_class (ctx, GTK_STYLE_CLASS_VIEW);
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_ = widget;
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp4_ = gtk_widget_get_state_flags (_tmp3_);
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_get_background_color (ctx, _tmp4_, &_tmp5_);
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	dest = _tmp5_;
#line 75 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp6_ = widget;
#line 75 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_ = dest;
#line 75 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_mix_in_color (self, _tmp6_, &_tmp7_);
#line 77 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_restore (ctx);
#line 67 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_g_object_unref0 (ctx);
#line 392 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_mix_in_color (GcaDiagnosticColors* self, GtkWidget* widget, GdkRGBA* dest) {
	GtkWidget* _tmp0_;
	GtkStyleContext* _tmp1_ = NULL;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* ctx;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_ = {0};
	GdkRGBA _tmp5_;
	GdkRGBA _tmp6_ = {0};
	GdkRGBA _tmp7_ = {0};
	GdkRGBA _tmp8_ = {0};
	GdkRGBA _tmp9_;
	GdkRGBA _tmp10_ = {0};
	GdkRGBA _tmp11_ = {0};
	GdkRGBA _tmp12_ = {0};
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_ = {0};
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (widget != NULL);
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (dest != NULL);
#line 82 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = widget;
#line 82 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_ = gtk_widget_get_style_context (_tmp0_);
#line 82 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 82 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	ctx = _tmp2_;
#line 84 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_save (ctx);
#line 86 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_add_class (ctx, GTK_STYLE_CLASS_VIEW);
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_.red = (gdouble) 1;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_.green = (gdouble) 0;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_.blue = (gdouble) 0;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_.alpha = (gdouble) 1;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, ctx, "error_bg_color", &_tmp3_, 0.5, &_tmp4_);
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp5_ = *dest;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_mix_colors (self, &_tmp4_, &_tmp5_, &_tmp6_);
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_errorColor = _tmp6_;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.red = (gdouble) 1;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.green = 0.5;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.blue = (gdouble) 0;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_.alpha = (gdouble) 1;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, ctx, "warning_bg_color", &_tmp7_, 0.5, &_tmp8_);
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp9_ = *dest;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_mix_colors (self, &_tmp8_, &_tmp9_, &_tmp10_);
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_warningColor = _tmp10_;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_.red = (gdouble) 0;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_.green = (gdouble) 0;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_.blue = (gdouble) 1;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_.alpha = (gdouble) 1;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_update_color (self, ctx, "info_bg_color", &_tmp11_, 0.5, &_tmp12_);
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp13_ = *dest;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_mix_colors (self, &_tmp12_, &_tmp13_, &_tmp14_);
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv->d_infoColor = _tmp14_;
#line 103 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gtk_style_context_restore (ctx);
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_g_object_unref0 (ctx);
#line 483 "gca-diagnostic-colors.c"
}


static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self) {
	GdkRGBA* dup;
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	dup = g_new0 (GdkRGBA, 1);
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	memcpy (dup, self, sizeof (GdkRGBA));
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return dup;
#line 495 "gca-diagnostic-colors.c"
}


static gpointer __gdk_rgba_dup0 (gpointer self) {
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return self ? _gdk_rgba_dup (self) : NULL;
#line 502 "gca-diagnostic-colors.c"
}


GdkRGBA* gca_diagnostic_colors_get (GcaDiagnosticColors* self, GcaDiagnosticSeverity severity) {
	GdkRGBA* result = NULL;
	GcaDiagnosticSeverity _tmp0_;
#line 106 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = severity;
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	switch (_tmp0_) {
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		case GCA_DIAGNOSTIC_SEVERITY_INFO:
#line 517 "gca-diagnostic-colors.c"
		{
			GdkRGBA _tmp1_;
			GdkRGBA* _tmp2_;
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp1_ = self->priv->d_infoColor;
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp2_ = __gdk_rgba_dup0 (&_tmp1_);
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			result = _tmp2_;
#line 111 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return result;
#line 529 "gca-diagnostic-colors.c"
		}
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		case GCA_DIAGNOSTIC_SEVERITY_WARNING:
#line 533 "gca-diagnostic-colors.c"
		{
			GdkRGBA _tmp3_;
			GdkRGBA* _tmp4_;
#line 113 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp3_ = self->priv->d_warningColor;
#line 113 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp4_ = __gdk_rgba_dup0 (&_tmp3_);
#line 113 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			result = _tmp4_;
#line 113 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return result;
#line 545 "gca-diagnostic-colors.c"
		}
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		case GCA_DIAGNOSTIC_SEVERITY_ERROR:
#line 108 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		case GCA_DIAGNOSTIC_SEVERITY_FATAL:
#line 551 "gca-diagnostic-colors.c"
		{
			GdkRGBA _tmp5_;
			GdkRGBA* _tmp6_;
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp5_ = self->priv->d_errorColor;
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			_tmp6_ = __gdk_rgba_dup0 (&_tmp5_);
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			result = _tmp6_;
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return result;
#line 563 "gca-diagnostic-colors.c"
		}
		default:
		{
#line 118 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			result = NULL;
#line 118 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return result;
#line 571 "gca-diagnostic-colors.c"
		}
	}
}


static void gca_diagnostic_colors_update_color (GcaDiagnosticColors* self, GtkStyleContext* context, const gchar* color_name, GdkRGBA* defcol, gdouble alpha, GdkRGBA* result) {
	GdkRGBA col = {0};
	GtkStyleContext* _tmp0_;
	const gchar* _tmp1_;
	GdkRGBA _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	gdouble s;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
	GdkRGBA _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble max;
	GdkRGBA _tmp13_;
	gdouble _tmp14_;
	GdkRGBA _tmp15_;
	gdouble _tmp16_;
	GdkRGBA _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble min;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble dm;
	gdouble _tmp23_;
	gdouble _tmp26_;
	gdouble _tmp30_;
	gdouble _tmp31_;
#line 137 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 137 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (context != NULL);
#line 137 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (color_name != NULL);
#line 137 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (defcol != NULL);
#line 144 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = context;
#line 144 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp1_ = color_name;
#line 144 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp3_ = gtk_style_context_lookup_color (_tmp0_, _tmp1_, &_tmp2_);
#line 144 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	col = _tmp2_;
#line 144 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (!_tmp3_) {
#line 627 "gca-diagnostic-colors.c"
		GdkRGBA _tmp4_;
#line 146 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp4_ = *defcol;
#line 146 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		col = _tmp4_;
#line 633 "gca-diagnostic-colors.c"
	}
#line 149 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	s = (gdouble) 0;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp5_ = col;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp6_ = _tmp5_.red;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp7_ = col;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp8_ = _tmp7_.green;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp9_ = col;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp10_ = _tmp9_.blue;
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp11_ = MAX (_tmp8_, _tmp10_);
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp12_ = MAX (_tmp6_, _tmp11_);
#line 151 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	max = _tmp12_;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp13_ = col;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp14_ = _tmp13_.red;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp15_ = col;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp16_ = _tmp15_.green;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp17_ = col;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp18_ = _tmp17_.blue;
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp19_ = MIN (_tmp16_, _tmp18_);
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp20_ = MIN (_tmp14_, _tmp19_);
#line 152 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	min = _tmp20_;
#line 154 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp21_ = max;
#line 154 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp22_ = min;
#line 154 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	dm = _tmp21_ - _tmp22_;
#line 156 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp23_ = dm;
#line 156 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (_tmp23_ != ((gdouble) 0)) {
#line 683 "gca-diagnostic-colors.c"
		gdouble _tmp24_;
		gdouble _tmp25_;
#line 158 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp24_ = dm;
#line 158 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp25_ = max;
#line 158 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		s = _tmp24_ / _tmp25_;
#line 692 "gca-diagnostic-colors.c"
	}
#line 161 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp26_ = s;
#line 161 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (_tmp26_ < 0.5) {
#line 698 "gca-diagnostic-colors.c"
		gdouble _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
#line 163 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp27_ = col.red;
#line 163 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		col.red = _tmp27_ * 0.5;
#line 164 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp28_ = col.blue;
#line 164 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		col.blue = _tmp28_ * 0.5;
#line 165 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		_tmp29_ = col.green;
#line 165 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		col.green = _tmp29_ * 0.5;
#line 714 "gca-diagnostic-colors.c"
	}
#line 168 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp30_ = col.alpha;
#line 168 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp31_ = alpha;
#line 168 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	col.alpha = _tmp30_ * _tmp31_;
#line 170 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	*result = col;
#line 170 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return;
#line 726 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_get_error_color (GcaDiagnosticColors* self, GdkRGBA* result) {
	GdkRGBA _tmp0_;
#line 124 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 124 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = self->priv->d_errorColor;
#line 124 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	*result = _tmp0_;
#line 124 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return;
#line 740 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_get_warning_color (GcaDiagnosticColors* self, GdkRGBA* result) {
	GdkRGBA _tmp0_;
#line 129 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 129 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = self->priv->d_warningColor;
#line 129 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	*result = _tmp0_;
#line 129 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return;
#line 754 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_get_info_color (GcaDiagnosticColors* self, GdkRGBA* result) {
	GdkRGBA _tmp0_;
#line 134 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (self != NULL);
#line 134 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	_tmp0_ = self->priv->d_infoColor;
#line 134 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	*result = _tmp0_;
#line 134 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return;
#line 768 "gca-diagnostic-colors.c"
}


static void gca_value_diagnostic_colors_init (GValue* value) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	value->data[0].v_pointer = NULL;
#line 775 "gca-diagnostic-colors.c"
}


static void gca_value_diagnostic_colors_free_value (GValue* value) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (value->data[0].v_pointer) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		gca_diagnostic_colors_unref (value->data[0].v_pointer);
#line 784 "gca-diagnostic-colors.c"
	}
}


static void gca_value_diagnostic_colors_copy_value (const GValue* src_value, GValue* dest_value) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		dest_value->data[0].v_pointer = gca_diagnostic_colors_ref (src_value->data[0].v_pointer);
#line 794 "gca-diagnostic-colors.c"
	} else {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		dest_value->data[0].v_pointer = NULL;
#line 798 "gca-diagnostic-colors.c"
	}
}


static gpointer gca_value_diagnostic_colors_peek_pointer (const GValue* value) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return value->data[0].v_pointer;
#line 806 "gca-diagnostic-colors.c"
}


static gchar* gca_value_diagnostic_colors_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (collect_values[0].v_pointer) {
#line 813 "gca-diagnostic-colors.c"
		GcaDiagnosticColors* object;
		object = collect_values[0].v_pointer;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 820 "gca-diagnostic-colors.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 824 "gca-diagnostic-colors.c"
		}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = gca_diagnostic_colors_ref (object);
#line 828 "gca-diagnostic-colors.c"
	} else {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = NULL;
#line 832 "gca-diagnostic-colors.c"
	}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return NULL;
#line 836 "gca-diagnostic-colors.c"
}


static gchar* gca_value_diagnostic_colors_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GcaDiagnosticColors** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (!object_p) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 847 "gca-diagnostic-colors.c"
	}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (!value->data[0].v_pointer) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		*object_p = NULL;
#line 853 "gca-diagnostic-colors.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		*object_p = value->data[0].v_pointer;
#line 857 "gca-diagnostic-colors.c"
	} else {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		*object_p = gca_diagnostic_colors_ref (value->data[0].v_pointer);
#line 861 "gca-diagnostic-colors.c"
	}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return NULL;
#line 865 "gca-diagnostic-colors.c"
}


GParamSpec* gca_param_spec_diagnostic_colors (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GcaParamSpecDiagnosticColors* spec;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GCA_TYPE_DIAGNOSTIC_COLORS), NULL);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return G_PARAM_SPEC (spec);
#line 879 "gca-diagnostic-colors.c"
}


gpointer gca_value_get_diagnostic_colors (const GValue* value) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GCA_TYPE_DIAGNOSTIC_COLORS), NULL);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return value->data[0].v_pointer;
#line 888 "gca-diagnostic-colors.c"
}


void gca_value_set_diagnostic_colors (GValue* value, gpointer v_object) {
	GcaDiagnosticColors* old;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GCA_TYPE_DIAGNOSTIC_COLORS));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	old = value->data[0].v_pointer;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (v_object) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GCA_TYPE_DIAGNOSTIC_COLORS));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = v_object;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		gca_diagnostic_colors_ref (value->data[0].v_pointer);
#line 908 "gca-diagnostic-colors.c"
	} else {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = NULL;
#line 912 "gca-diagnostic-colors.c"
	}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (old) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		gca_diagnostic_colors_unref (old);
#line 918 "gca-diagnostic-colors.c"
	}
}


void gca_value_take_diagnostic_colors (GValue* value, gpointer v_object) {
	GcaDiagnosticColors* old;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GCA_TYPE_DIAGNOSTIC_COLORS));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	old = value->data[0].v_pointer;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (v_object) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GCA_TYPE_DIAGNOSTIC_COLORS));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = v_object;
#line 937 "gca-diagnostic-colors.c"
	} else {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		value->data[0].v_pointer = NULL;
#line 941 "gca-diagnostic-colors.c"
	}
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (old) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		gca_diagnostic_colors_unref (old);
#line 947 "gca-diagnostic-colors.c"
	}
}


static void gca_diagnostic_colors_class_init (GcaDiagnosticColorsClass * klass) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	gca_diagnostic_colors_parent_class = g_type_class_peek_parent (klass);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	GCA_DIAGNOSTIC_COLORS_CLASS (klass)->finalize = gca_diagnostic_colors_finalize;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_type_class_add_private (klass, sizeof (GcaDiagnosticColorsPrivate));
#line 959 "gca-diagnostic-colors.c"
}


static void gca_diagnostic_colors_instance_init (GcaDiagnosticColors * self) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->priv = GCA_DIAGNOSTIC_COLORS_GET_PRIVATE (self);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self->ref_count = 1;
#line 968 "gca-diagnostic-colors.c"
}


static void gca_diagnostic_colors_finalize (GcaDiagnosticColors* obj) {
	GcaDiagnosticColors * self;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCA_TYPE_DIAGNOSTIC_COLORS, GcaDiagnosticColors);
#line 976 "gca-diagnostic-colors.c"
}


GType gca_diagnostic_colors_get_type (void) {
	static volatile gsize gca_diagnostic_colors_type_id__volatile = 0;
	if (g_once_init_enter (&gca_diagnostic_colors_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gca_value_diagnostic_colors_init, gca_value_diagnostic_colors_free_value, gca_value_diagnostic_colors_copy_value, gca_value_diagnostic_colors_peek_pointer, "p", gca_value_diagnostic_colors_collect_value, "p", gca_value_diagnostic_colors_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GcaDiagnosticColorsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gca_diagnostic_colors_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GcaDiagnosticColors), 0, (GInstanceInitFunc) gca_diagnostic_colors_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gca_diagnostic_colors_type_id;
		gca_diagnostic_colors_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GcaDiagnosticColors", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gca_diagnostic_colors_type_id__volatile, gca_diagnostic_colors_type_id);
	}
	return gca_diagnostic_colors_type_id__volatile;
}


gpointer gca_diagnostic_colors_ref (gpointer instance) {
	GcaDiagnosticColors* self;
	self = instance;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	return instance;
#line 1001 "gca-diagnostic-colors.c"
}


void gca_diagnostic_colors_unref (gpointer instance) {
	GcaDiagnosticColors* self;
	self = instance;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		GCA_DIAGNOSTIC_COLORS_GET_CLASS (self)->finalize (self);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-diagnostic-colors.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1014 "gca-diagnostic-colors.c"
	}
}



