/* gca-source-location.c generated by valac 0.20.1, the Vala compiler
 * generated from gca-source-location.vala, do not modify */

/*
 * This file is part of gedit-code-assistant.
 *
 * Copyright (C) 2011 - Jesse van den Kieboom
 *
 * gedit-code-assistant is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gedit-code-assistant is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gedit-code-assistant.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <string.h>
#include <gdk/gdk.h>
#include <stdlib.h>


#define GCA_TYPE_SOURCE_LOCATION (gca_source_location_get_type ())
typedef struct _GcaSourceLocation GcaSourceLocation;

#define GCA_DBUS_TYPE_SOURCE_LOCATION (gca_dbus_source_location_get_type ())
typedef struct _GcaDBusSourceLocation GcaDBusSourceLocation;

#define GCA_TYPE_SOURCE_RANGE (gca_source_range_get_type ())
typedef struct _GcaSourceRange GcaSourceRange;

struct _GcaSourceLocation {
	gint line;
	gint column;
};

struct _GcaDBusSourceLocation {
	gint64 line;
	gint64 column;
};

struct _GcaSourceRange {
	GcaSourceLocation start;
	GcaSourceLocation end;
};



GType gca_source_location_get_type (void) G_GNUC_CONST;
GcaSourceLocation* gca_source_location_dup (const GcaSourceLocation* self);
void gca_source_location_free (GcaSourceLocation* self);
void gca_source_location_from_iter (GtkTextIter* iter, GcaSourceLocation* result);
GType gca_dbus_source_location_get_type (void) G_GNUC_CONST;
GcaDBusSourceLocation* gca_dbus_source_location_dup (const GcaDBusSourceLocation* self);
void gca_dbus_source_location_free (GcaDBusSourceLocation* self);
void gca_source_location_from_dbus (GcaDBusSourceLocation* location, GcaSourceLocation* result);
GType gca_source_range_get_type (void) G_GNUC_CONST;
GcaSourceRange* gca_source_range_dup (const GcaSourceRange* self);
void gca_source_range_free (GcaSourceRange* self);
void gca_source_location_to_range (GcaSourceLocation *self, GcaSourceRange* result);
static gint gca_source_location_compare_int (GcaSourceLocation *self, gint a, gint b);
gint gca_source_location_compare_to (GcaSourceLocation *self, GcaSourceLocation* other);
gboolean gca_source_location_get_iter (GcaSourceLocation *self, GtkTextBuffer* buffer, GtkTextIter* iter);
gboolean gca_source_location_buffer_coordinates (GcaSourceLocation *self, GtkTextView* view, GdkRectangle* rect);
gchar* gca_source_location_to_string (GcaSourceLocation *self);


void gca_source_location_from_iter (GtkTextIter* iter, GcaSourceLocation* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GcaSourceLocation _tmp2_ = {0};
#line 31 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_return_if_fail (iter != NULL);
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = gtk_text_iter_get_line (iter);
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = gtk_text_iter_get_line_offset (iter);
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	memset (&_tmp2_, 0, sizeof (GcaSourceLocation));
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_.line = _tmp0_ + 1;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_.column = _tmp1_ + 1;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	*result = _tmp2_;
#line 33 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return;
#line 97 "gca-source-location.c"
}


void gca_source_location_from_dbus (GcaDBusSourceLocation* location, GcaSourceLocation* result) {
	GcaDBusSourceLocation _tmp0_;
	gint64 _tmp1_;
	GcaDBusSourceLocation _tmp2_;
	gint64 _tmp3_;
	GcaSourceLocation _tmp4_ = {0};
#line 39 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_return_if_fail (location != NULL);
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = *location;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = _tmp0_.line;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_ = *location;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp3_ = _tmp2_.column;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	memset (&_tmp4_, 0, sizeof (GcaSourceLocation));
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp4_.line = (gint) _tmp1_;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp4_.column = (gint) _tmp3_;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	*result = _tmp4_;
#line 41 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return;
#line 127 "gca-source-location.c"
}


void gca_source_location_to_range (GcaSourceLocation *self, GcaSourceRange* result) {
	GcaSourceRange _tmp0_ = {0};
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	memset (&_tmp0_, 0, sizeof (GcaSourceRange));
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_.start = (*self);
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_.end = (*self);
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	*result = _tmp0_;
#line 49 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return;
#line 143 "gca-source-location.c"
}


static gint gca_source_location_compare_int (GcaSourceLocation *self, gint a, gint b) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp7_;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = a;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_ = b;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (_tmp1_ < _tmp2_) {
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp0_ = -1;
#line 161 "gca-source-location.c"
	} else {
		gint _tmp3_ = 0;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp4_ = a;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp5_ = b;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		if (_tmp4_ == _tmp5_) {
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			_tmp3_ = 0;
#line 175 "gca-source-location.c"
		} else {
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			_tmp3_ = 1;
#line 179 "gca-source-location.c"
		}
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp6_ = _tmp3_;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp0_ = _tmp6_;
#line 185 "gca-source-location.c"
	}
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp7_ = _tmp0_;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	result = _tmp7_;
#line 57 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return result;
#line 193 "gca-source-location.c"
}


gint gca_source_location_compare_to (GcaSourceLocation *self, GcaSourceLocation* other) {
	gint result = 0;
	gint _tmp0_;
	GcaSourceLocation _tmp1_;
	gint _tmp2_;
#line 60 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 62 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = (*self).line;
#line 62 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = *other;
#line 62 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_ = _tmp1_.line;
#line 62 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (_tmp0_ == _tmp2_) {
#line 212 "gca-source-location.c"
		gint _tmp3_;
		GcaSourceLocation _tmp4_;
		gint _tmp5_;
		gint _tmp6_ = 0;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp3_ = (*self).column;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp4_ = *other;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp5_ = _tmp4_.column;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp6_ = gca_source_location_compare_int (&(*self), _tmp3_, _tmp5_);
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		result = _tmp6_;
#line 64 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		return result;
#line 229 "gca-source-location.c"
	} else {
		gint _tmp7_;
		GcaSourceLocation _tmp8_;
		gint _tmp9_;
		gint _tmp10_ = 0;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp7_ = (*self).line;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp8_ = *other;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp9_ = _tmp8_.line;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp10_ = gca_source_location_compare_int (&(*self), _tmp7_, _tmp9_);
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		result = _tmp10_;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		return result;
#line 247 "gca-source-location.c"
	}
}


gboolean gca_source_location_get_iter (GcaSourceLocation *self, GtkTextBuffer* buffer, GtkTextIter* iter) {
	GtkTextIter _vala_iter = {0};
	gboolean result = FALSE;
	GtkTextBuffer* _tmp0_;
	gint _tmp1_;
	GtkTextIter _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint _tmp4_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean ret;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp12_;
#line 72 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_return_val_if_fail (buffer != NULL, FALSE);
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = buffer;
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = (*self).line;
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	gtk_text_buffer_get_iter_at_line (_tmp0_, &_tmp2_, _tmp1_ - 1);
#line 74 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_vala_iter = _tmp2_;
#line 76 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp3_ = gtk_text_iter_get_line (&_vala_iter);
#line 76 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp4_ = (*self).line;
#line 76 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (_tmp3_ != (_tmp4_ - 1)) {
#line 283 "gca-source-location.c"
		gboolean _tmp5_ = FALSE;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp5_ = gtk_text_iter_is_end (&_vala_iter);
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		if (_tmp5_) {
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			result = TRUE;
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			if (iter) {
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
				*iter = _vala_iter;
#line 295 "gca-source-location.c"
			}
#line 80 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			return result;
#line 299 "gca-source-location.c"
		}
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		result = FALSE;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		if (iter) {
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			*iter = _vala_iter;
#line 307 "gca-source-location.c"
		}
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		return result;
#line 311 "gca-source-location.c"
	}
#line 86 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp6_ = (*self).column;
#line 86 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (_tmp6_ <= 1) {
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		result = TRUE;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		if (iter) {
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			*iter = _vala_iter;
#line 323 "gca-source-location.c"
		}
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		return result;
#line 327 "gca-source-location.c"
	}
#line 91 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp7_ = (*self).column;
#line 91 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp8_ = gtk_text_iter_forward_chars (&_vala_iter, _tmp7_ - 1);
#line 91 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	ret = _tmp8_;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp10_ = ret;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (!_tmp10_) {
#line 339 "gca-source-location.c"
		gboolean _tmp11_ = FALSE;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp11_ = gtk_text_iter_is_end (&_vala_iter);
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp9_ = _tmp11_;
#line 345 "gca-source-location.c"
	} else {
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		_tmp9_ = FALSE;
#line 349 "gca-source-location.c"
	}
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp12_ = _tmp9_;
#line 93 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (_tmp12_) {
#line 95 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		ret = TRUE;
#line 357 "gca-source-location.c"
	}
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	result = ret;
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (iter) {
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		*iter = _vala_iter;
#line 365 "gca-source-location.c"
	}
#line 98 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return result;
#line 369 "gca-source-location.c"
}


gboolean gca_source_location_buffer_coordinates (GcaSourceLocation *self, GtkTextView* view, GdkRectangle* rect) {
	GdkRectangle _vala_rect = {0};
	gboolean result = FALSE;
	GtkTextIter iter = {0};
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextIter _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	GtkTextView* _tmp5_;
	GtkTextIter _tmp6_;
	GdkRectangle _tmp7_ = {0};
	GtkTextView* _tmp8_;
	GtkTextIter _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
#line 101 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_return_val_if_fail (view != NULL, FALSE);
#line 105 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	memset (&_vala_rect, 0, sizeof (GdkRectangle));
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = view;
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_ = _tmp1_;
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp4_ = gca_source_location_get_iter (&(*self), _tmp2_, &_tmp3_);
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	iter = _tmp3_;
#line 107 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (!_tmp4_) {
#line 109 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		result = FALSE;
#line 109 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		if (rect) {
#line 109 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
			*rect = _vala_rect;
#line 411 "gca-source-location.c"
		}
#line 109 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		return result;
#line 415 "gca-source-location.c"
	}
#line 112 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp5_ = view;
#line 112 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp6_ = iter;
#line 112 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	gtk_text_view_get_iter_location (_tmp5_, &_tmp6_, &_tmp7_);
#line 112 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_vala_rect = _tmp7_;
#line 115 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp8_ = view;
#line 115 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp9_ = iter;
#line 115 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	gtk_text_view_get_line_yrange (_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 115 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_vala_rect.y = _tmp10_;
#line 115 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_vala_rect.height = _tmp11_;
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	result = TRUE;
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	if (rect) {
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
		*rect = _vala_rect;
#line 441 "gca-source-location.c"
	}
#line 116 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return result;
#line 445 "gca-source-location.c"
}


gchar* gca_source_location_to_string (GcaSourceLocation *self) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
#line 121 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp0_ = (*self).line;
#line 121 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp1_ = (*self).column;
#line 121 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	_tmp2_ = g_strdup_printf ("(%d.%d)", _tmp0_, _tmp1_);
#line 121 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	result = _tmp2_;
#line 121 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return result;
#line 464 "gca-source-location.c"
}


GcaSourceLocation* gca_source_location_dup (const GcaSourceLocation* self) {
	GcaSourceLocation* dup;
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	dup = g_new0 (GcaSourceLocation, 1);
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	memcpy (dup, self, sizeof (GcaSourceLocation));
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	return dup;
#line 476 "gca-source-location.c"
}


void gca_source_location_free (GcaSourceLocation* self) {
#line 25 "/home/jesse/devel/gedit-code-assistance/src/gca-source-location.vala"
	g_free (self);
#line 483 "gca-source-location.c"
}


GType gca_source_location_get_type (void) {
	static volatile gsize gca_source_location_type_id__volatile = 0;
	if (g_once_init_enter (&gca_source_location_type_id__volatile)) {
		GType gca_source_location_type_id;
		gca_source_location_type_id = g_boxed_type_register_static ("GcaSourceLocation", (GBoxedCopyFunc) gca_source_location_dup, (GBoxedFreeFunc) gca_source_location_free);
		g_once_init_leave (&gca_source_location_type_id__volatile, gca_source_location_type_id);
	}
	return gca_source_location_type_id__volatile;
}



