/* gca-source-range.c generated by valac 0.20.1, the Vala compiler
 * generated from gca-source-range.vala, do not modify */

/*
 * This file is part of gedit-code-assistant.
 *
 * Copyright (C) 2011 - Jesse van den Kieboom
 *
 * gedit-code-assistant is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gedit-code-assistant is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gedit-code-assistant.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>


#define GCA_TYPE_SOURCE_RANGE (gca_source_range_get_type ())

#define GCA_TYPE_SOURCE_LOCATION (gca_source_location_get_type ())
typedef struct _GcaSourceLocation GcaSourceLocation;
typedef struct _GcaSourceRange GcaSourceRange;

#define GCA_DBUS_TYPE_SOURCE_RANGE (gca_dbus_source_range_get_type ())

#define GCA_DBUS_TYPE_SOURCE_LOCATION (gca_dbus_source_location_get_type ())
typedef struct _GcaDBusSourceLocation GcaDBusSourceLocation;
typedef struct _GcaDBusSourceRange GcaDBusSourceRange;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GcaSourceLocation {
	gint line;
	gint column;
};

struct _GcaSourceRange {
	GcaSourceLocation start;
	GcaSourceLocation end;
};

struct _GcaDBusSourceLocation {
	gint64 line;
	gint64 column;
};

struct _GcaDBusSourceRange {
	gint64 file;
	GcaDBusSourceLocation start;
	GcaDBusSourceLocation end;
};



GType gca_source_range_get_type (void) G_GNUC_CONST;
GType gca_source_location_get_type (void) G_GNUC_CONST;
GcaSourceLocation* gca_source_location_dup (const GcaSourceLocation* self);
void gca_source_location_free (GcaSourceLocation* self);
GcaSourceRange* gca_source_range_dup (const GcaSourceRange* self);
void gca_source_range_free (GcaSourceRange* self);
void gca_source_range_from_iter (GtkTextIter* iter, GcaSourceRange* result);
void gca_source_location_from_iter (GtkTextIter* iter, GcaSourceLocation* result);
GType gca_dbus_source_range_get_type (void) G_GNUC_CONST;
GType gca_dbus_source_location_get_type (void) G_GNUC_CONST;
GcaDBusSourceLocation* gca_dbus_source_location_dup (const GcaDBusSourceLocation* self);
void gca_dbus_source_location_free (GcaDBusSourceLocation* self);
GcaDBusSourceRange* gca_dbus_source_range_dup (const GcaDBusSourceRange* self);
void gca_dbus_source_range_free (GcaDBusSourceRange* self);
void gca_source_range_from_dbus (GcaDBusSourceRange* range, GcaSourceRange* result);
void gca_source_location_from_dbus (GcaDBusSourceLocation* location, GcaSourceLocation* result);
gint gca_source_range_compare_to (GcaSourceRange *self, GcaSourceRange* other);
gint gca_source_location_compare_to (GcaSourceLocation *self, GcaSourceLocation* other);
gboolean gca_source_range_get_iters (GcaSourceRange *self, GtkTextBuffer* buffer, GtkTextIter* start, GtkTextIter* end);
gboolean gca_source_location_get_iter (GcaSourceLocation *self, GtkTextBuffer* buffer, GtkTextIter* iter);
gboolean gca_source_range_contains_range (GcaSourceRange *self, GcaSourceRange* range);
gboolean gca_source_range_contains_location (GcaSourceRange *self, GcaSourceLocation* location);
gboolean gca_source_range_contains (GcaSourceRange *self, gint line, gint column);
gboolean gca_source_range_contains_line (GcaSourceRange *self, gint line);
gchar* gca_source_range_to_string (GcaSourceRange *self);
gchar* gca_source_location_to_string (GcaSourceLocation *self);


void gca_source_range_from_iter (GtkTextIter* iter, GcaSourceRange* result) {
	GtkTextIter _tmp0_;
	GcaSourceLocation _tmp1_ = {0};
	GcaSourceLocation loc;
	GcaSourceLocation _tmp2_;
	GcaSourceLocation _tmp3_;
	GcaSourceRange _tmp4_ = {0};
#line 28 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_if_fail (iter != NULL);
#line 30 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp0_ = *iter;
#line 30 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	gca_source_location_from_iter (&_tmp0_, &_tmp1_);
#line 30 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	loc = _tmp1_;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = loc;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = loc;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	memset (&_tmp4_, 0, sizeof (GcaSourceRange));
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_.start = _tmp2_;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_.end = _tmp3_;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	*result = _tmp4_;
#line 32 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return;
#line 124 "gca-source-range.c"
}


void gca_source_range_from_dbus (GcaDBusSourceRange* range, GcaSourceRange* result) {
	GcaDBusSourceRange _tmp0_;
	GcaDBusSourceLocation _tmp1_;
	GcaSourceLocation _tmp2_ = {0};
	GcaDBusSourceRange _tmp3_;
	GcaDBusSourceLocation _tmp4_;
	GcaSourceLocation _tmp5_ = {0};
	GcaSourceRange _tmp6_ = {0};
#line 38 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_if_fail (range != NULL);
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp0_ = *range;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = _tmp0_.start;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	gca_source_location_from_dbus (&_tmp1_, &_tmp2_);
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = *range;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_ = _tmp3_.end;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	gca_source_location_from_dbus (&_tmp4_, &_tmp5_);
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	memset (&_tmp6_, 0, sizeof (GcaSourceRange));
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp6_.start = _tmp2_;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp6_.end = _tmp5_;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	*result = _tmp6_;
#line 40 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return;
#line 160 "gca-source-range.c"
}


gint gca_source_range_compare_to (GcaSourceRange *self, GcaSourceRange* other) {
	gint result = 0;
	GcaSourceRange _tmp0_;
	GcaSourceLocation _tmp1_;
	gint _tmp2_ = 0;
	gint st;
	gint _tmp3_;
#line 46 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 48 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp0_ = *other;
#line 48 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = _tmp0_.start;
#line 48 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = gca_source_location_compare_to (&(*self).start, &_tmp1_);
#line 48 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	st = _tmp2_;
#line 50 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = st;
#line 50 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp3_ == 0) {
#line 185 "gca-source-range.c"
		GcaSourceLocation _tmp4_;
		gint _tmp5_ = 0;
#line 52 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp4_ = (*self).end;
#line 52 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp5_ = gca_source_location_compare_to (&(*other).end, &_tmp4_);
#line 52 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		st = _tmp5_;
#line 194 "gca-source-range.c"
	}
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = st;
#line 55 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 200 "gca-source-range.c"
}


gboolean gca_source_range_get_iters (GcaSourceRange *self, GtkTextBuffer* buffer, GtkTextIter* start, GtkTextIter* end) {
	GtkTextIter _vala_start = {0};
	GtkTextIter _vala_end = {0};
	gboolean result = FALSE;
	gboolean rets = FALSE;
	gboolean rete = FALSE;
	GtkTextBuffer* _tmp0_;
	GtkTextIter _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GtkTextBuffer* _tmp3_;
	GtkTextIter _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp13_;
#line 58 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_val_if_fail (buffer != NULL, FALSE);
#line 65 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp0_ = buffer;
#line 65 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = gca_source_location_get_iter (&(*self).start, _tmp0_, &_tmp1_);
#line 65 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_vala_start = _tmp1_;
#line 65 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	rets = _tmp2_;
#line 66 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = buffer;
#line 66 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp5_ = gca_source_location_get_iter (&(*self).end, _tmp3_, &_tmp4_);
#line 66 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_vala_end = _tmp4_;
#line 66 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	rete = _tmp5_;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp7_ = rete;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp7_) {
#line 244 "gca-source-range.c"
		gboolean _tmp8_ = FALSE;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp8_ = gtk_text_iter_ends_line (&_vala_end);
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = !_tmp8_;
#line 250 "gca-source-range.c"
	} else {
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = FALSE;
#line 254 "gca-source-range.c"
	}
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp9_ = _tmp6_;
#line 68 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp9_) {
#line 70 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		gtk_text_iter_forward_char (&_vala_end);
#line 262 "gca-source-range.c"
	}
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp11_ = rets;
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp11_) {
#line 268 "gca-source-range.c"
		gboolean _tmp12_;
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp12_ = rete;
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp10_ = _tmp12_;
#line 274 "gca-source-range.c"
	} else {
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp10_ = FALSE;
#line 278 "gca-source-range.c"
	}
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp13_ = _tmp10_;
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp13_;
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (start) {
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		*start = _vala_start;
#line 288 "gca-source-range.c"
	}
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (end) {
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		*end = _vala_end;
#line 294 "gca-source-range.c"
	}
#line 73 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 298 "gca-source-range.c"
}


gboolean gca_source_range_contains_range (GcaSourceRange *self, GcaSourceRange* range) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GcaSourceRange _tmp1_;
	GcaSourceLocation _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp7_;
#line 76 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_val_if_fail (range != NULL, FALSE);
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = *range;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = _tmp1_.start;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = gca_source_range_contains_location (&(*self), &_tmp2_);
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp3_) {
#line 319 "gca-source-range.c"
		GcaSourceRange _tmp4_;
		GcaSourceLocation _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp4_ = *range;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp5_ = _tmp4_.end;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = gca_source_range_contains_location (&(*self), &_tmp5_);
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = _tmp6_;
#line 331 "gca-source-range.c"
	} else {
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = FALSE;
#line 335 "gca-source-range.c"
	}
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp7_ = _tmp0_;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp7_;
#line 78 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 343 "gca-source-range.c"
}


gboolean gca_source_range_contains_location (GcaSourceRange *self, GcaSourceLocation* location) {
	gboolean result = FALSE;
	GcaSourceLocation _tmp0_;
	gint _tmp1_;
	GcaSourceLocation _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 81 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_return_val_if_fail (location != NULL, FALSE);
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp0_ = *location;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = _tmp0_.line;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = *location;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = _tmp2_.column;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_ = gca_source_range_contains (&(*self), _tmp1_, _tmp3_);
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp4_;
#line 83 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 370 "gca-source-range.c"
}


gboolean gca_source_range_contains (GcaSourceRange *self, gint line, gint column) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GcaSourceLocation _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp13_;
	gboolean _tmp27_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = (*self).start;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = _tmp2_.line;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_ = line;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp3_ < _tmp4_) {
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp1_ = TRUE;
#line 393 "gca-source-range.c"
	} else {
		gboolean _tmp5_ = FALSE;
		GcaSourceLocation _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gboolean _tmp12_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = (*self).start;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp7_ = _tmp6_.line;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp8_ = line;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		if (_tmp7_ == _tmp8_) {
#line 408 "gca-source-range.c"
			GcaSourceLocation _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp9_ = (*self).start;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp10_ = _tmp9_.column;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp11_ = column;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp5_ = _tmp10_ <= _tmp11_;
#line 420 "gca-source-range.c"
		} else {
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp5_ = FALSE;
#line 424 "gca-source-range.c"
		}
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp12_ = _tmp5_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp1_ = _tmp12_;
#line 430 "gca-source-range.c"
	}
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp13_ = _tmp1_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp13_) {
#line 436 "gca-source-range.c"
		gboolean _tmp14_ = FALSE;
		GcaSourceLocation _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gboolean _tmp26_;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp15_ = (*self).end;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp16_ = _tmp15_.line;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp17_ = line;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		if (_tmp16_ > _tmp17_) {
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp14_ = TRUE;
#line 452 "gca-source-range.c"
		} else {
			gboolean _tmp18_ = FALSE;
			GcaSourceLocation _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gboolean _tmp25_;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp19_ = (*self).end;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp20_ = _tmp19_.line;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp21_ = line;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			if (_tmp20_ == _tmp21_) {
#line 467 "gca-source-range.c"
				GcaSourceLocation _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
				_tmp22_ = (*self).end;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
				_tmp23_ = _tmp22_.column;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
				_tmp24_ = column;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
				_tmp18_ = _tmp23_ >= _tmp24_;
#line 479 "gca-source-range.c"
			} else {
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
				_tmp18_ = FALSE;
#line 483 "gca-source-range.c"
			}
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp25_ = _tmp18_;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
			_tmp14_ = _tmp25_;
#line 489 "gca-source-range.c"
		}
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp26_ = _tmp14_;
#line 89 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = _tmp26_;
#line 495 "gca-source-range.c"
	} else {
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = FALSE;
#line 499 "gca-source-range.c"
	}
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp27_ = _tmp0_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp27_;
#line 88 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 507 "gca-source-range.c"
}


gboolean gca_source_range_contains_line (GcaSourceRange *self, gint line) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GcaSourceLocation _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp7_;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = (*self).start;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = _tmp1_.line;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = line;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp2_ <= _tmp3_) {
#line 526 "gca-source-range.c"
		GcaSourceLocation _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp4_ = (*self).end;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp5_ = _tmp4_.line;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = line;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = _tmp5_ >= _tmp6_;
#line 538 "gca-source-range.c"
	} else {
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = FALSE;
#line 542 "gca-source-range.c"
	}
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp7_ = _tmp0_;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp7_;
#line 94 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 550 "gca-source-range.c"
}


gchar* gca_source_range_to_string (GcaSourceRange *self) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	GcaSourceLocation _tmp1_;
	gint _tmp2_;
	GcaSourceLocation _tmp3_;
	gint _tmp4_;
	gboolean _tmp9_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp1_ = (*self).start;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp2_ = _tmp1_.line;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp3_ = (*self).end;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp4_ = _tmp3_.line;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp2_ == _tmp4_) {
#line 578 "gca-source-range.c"
		GcaSourceLocation _tmp5_;
		gint _tmp6_;
		GcaSourceLocation _tmp7_;
		gint _tmp8_;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp5_ = (*self).end;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp6_ = _tmp5_.column;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp7_ = (*self).start;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp8_ = _tmp7_.column;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = (_tmp6_ - _tmp8_) <= 1;
#line 593 "gca-source-range.c"
	} else {
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp0_ = FALSE;
#line 597 "gca-source-range.c"
	}
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp9_ = _tmp0_;
#line 99 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	if (_tmp9_) {
#line 603 "gca-source-range.c"
		gchar* _tmp10_ = NULL;
#line 101 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		_tmp10_ = gca_source_location_to_string (&(*self).start);
#line 101 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		result = _tmp10_;
#line 101 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
		return result;
#line 611 "gca-source-range.c"
	}
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp11_ = gca_source_location_to_string (&(*self).start);
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp12_ = _tmp11_;
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp13_ = gca_source_location_to_string (&(*self).end);
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp14_ = _tmp13_;
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp15_ = g_strdup_printf ("%s-%s", _tmp12_, _tmp14_);
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_tmp16_ = _tmp15_;
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_g_free0 (_tmp14_);
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	_g_free0 (_tmp12_);
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	result = _tmp16_;
#line 104 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return result;
#line 633 "gca-source-range.c"
}


GcaSourceRange* gca_source_range_dup (const GcaSourceRange* self) {
	GcaSourceRange* dup;
#line 23 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	dup = g_new0 (GcaSourceRange, 1);
#line 23 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	memcpy (dup, self, sizeof (GcaSourceRange));
#line 23 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	return dup;
#line 645 "gca-source-range.c"
}


void gca_source_range_free (GcaSourceRange* self) {
#line 23 "/home/jesse/devel/gedit-code-assistance/src/gca-source-range.vala"
	g_free (self);
#line 652 "gca-source-range.c"
}


GType gca_source_range_get_type (void) {
	static volatile gsize gca_source_range_type_id__volatile = 0;
	if (g_once_init_enter (&gca_source_range_type_id__volatile)) {
		GType gca_source_range_type_id;
		gca_source_range_type_id = g_boxed_type_register_static ("GcaSourceRange", (GBoxedCopyFunc) gca_source_range_dup, (GBoxedFreeFunc) gca_source_range_free);
		g_once_init_leave (&gca_source_range_type_id__volatile, gca_source_range_type_id);
	}
	return gca_source_range_type_id__volatile;
}



